package it.openutils.configuration.dataobjects;

import java.io.Serializable;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.Table;
import javax.xml.bind.annotation.XmlRootElement;
import javax.xml.bind.annotation.XmlType;


/**
 * @author fcarone
 * @version $Id: ConfigurationCode.java 177 2007-02-01 15:27:29Z fcarone $
 */

@Entity
@Table(name = "APP_CONFIGURATION_CODE")
@XmlType(name = "")
@XmlRootElement(name = "configurationCode")
public class ConfigurationCode implements Serializable
{

    /**
     * Stable serialVersionUID
     */
    private static final long serialVersionUID = 42L;

    @Id
    @GeneratedValue(strategy = GenerationType.AUTO)
    @Column(name = "ID_CONFIGURATIONCODE")
    private Long id;

    @ManyToOne(fetch = FetchType.EAGER, optional = false)
    @JoinColumn(name = "ID_CONFIGURATIONDOMAIN")
    private ConfigurationDomain configurationdomain;

    @Column(name = "CODE", nullable = false, length = 255)
    private String code;

    @Column(name = "DESCRIPTION", nullable = false, length = 255)
    private String description;

    @Column(name = "TYPE", nullable = false, length = 255)
    private String type;

    @Column(name = "VALUE", nullable = false, length = 255)
    private String value;

    /**
     * Returns the configurationdomain.
     * @return the configurationdomain
     */
    public ConfigurationDomain getConfigurationdomain()
    {
        return configurationdomain;
    }

    /**
     * Sets the configurationdomain.
     * @param configurationdomain the configurationdomain to set
     */
    public void setConfigurationdomain(ConfigurationDomain configurationdomain)
    {
        this.configurationdomain = configurationdomain;
    }

    /**
     * Returns the description.
     * @return the description
     */
    public String getDescription()
    {
        return description;
    }

    /**
     * Sets the description.
     * @param description the description to set
     */
    public void setDescription(String description)
    {
        this.description = description;
    }

    /**
     * Returns the id.
     * @return the id
     */
    public Long getId()
    {
        return id;
    }

    /**
     * Sets the id.
     * @param id the id to set
     */
    public void setId(Long id)
    {
        this.id = id;
    }

    /**
     * Returns the type.
     * @return the type
     */
    public String getType()
    {
        return type;
    }

    /**
     * Sets the type.
     * @param type the type to set
     */
    public void setType(String type)
    {
        this.type = type;
    }

    /**
     * Returns the value.
     * @return the value
     */
    public String getValue()
    {
        return value;
    }

    /**
     * Sets the value.
     * @param value the value to set
     */
    public void setValue(String value)
    {
        this.value = value;
    }

    public String getCode()
    {
        return code;
    }

    public void setCode(String code)
    {
        this.code = code;
    }

}
