package it.openutils.configuration.dataobjects;

import java.io.Serializable;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.Table;
import javax.xml.bind.annotation.XmlRootElement;
import javax.xml.bind.annotation.XmlType;


/**
 * @author fcarone
 * @version $Id: ConfigurationDomain.java 177 2007-02-01 15:27:29Z fcarone $
 */

@Entity
@Table(name = "APP_CONFIGURATION_DOMAIN")
@XmlType(name = "")
@XmlRootElement(name = "configurationDomain")
public class ConfigurationDomain implements Serializable
{

    /**
     * Stable serialVersionUID
     */
    private static final long serialVersionUID = 42L;

    @Id
    @Column(name = "ID_CONFIGURATIONDOMAIN", nullable = false, length = 60)
    private String id;

    @Column(name = "DESCRIPTION", length = 255)
    private String description;

    /**
     * Returns the description.
     * @return the description
     */
    public String getDescription()
    {
        return description;
    }

    /**
     * Sets the description.
     * @param description the description to set
     */
    public void setDescription(String description)
    {
        this.description = description;
    }

    /**
     * Returns the id.
     * @return the id
     */
    public String getId()
    {
        return id;
    }

    /**
     * Sets the id.
     * @param id the id to set
     */
    public void setId(String id)
    {
        this.id = id;
    }

}
