package it.openutils.configuration.dataobjects;

import java.io.Serializable;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.Table;
import javax.xml.bind.annotation.XmlRootElement;
import javax.xml.bind.annotation.XmlType;

import org.apache.commons.lang.builder.CompareToBuilder;
import org.apache.commons.lang.builder.EqualsBuilder;
import org.apache.commons.lang.builder.HashCodeBuilder;


/**
 * @author fcarone
 * @version $Id: ReferenceCode.java 177 2007-02-01 15:27:29Z fcarone $
 */
@Entity
@Table(name = "APP_REFERENCE_CODE")
@XmlType(name = "")
@XmlRootElement(name = "referenceCode")
public class ReferenceCode implements Comparable<ReferenceCode>, Serializable
{

    /**
     * Stable serialVersionUID
     */
    private static final long serialVersionUID = 42L;

    @Id
    @GeneratedValue(strategy = GenerationType.AUTO)
    @Column(name = "ID_REFERENCECODE")
    private Long id;

    @ManyToOne(fetch = FetchType.EAGER, optional = false)
    @JoinColumn(name = "ID_REFERENCEDOMAIN")
    private ReferenceDomain referencedomain;

    @Column(name = "CODE", nullable = false, length = 255)
    private String code;

    @Column(name = "DESCRIPTION", nullable = false, length = 255)
    private String description;

    @Column(name = "ACTIVE", nullable = false)
    private Boolean active;

    /**
     * Returns the active.
     * @return the active
     */
    public Boolean getActive()
    {
        return active;
    }

    /**
     * Sets the active.
     * @param active the active to set
     */
    public void setActive(Boolean active)
    {
        this.active = active;
    }

    /**
     * Returns the code.
     * @return the code
     */
    public String getCode()
    {
        return code;
    }

    /**
     * Sets the code.
     * @param code the code to set
     */
    public void setCode(String code)
    {
        this.code = code;
    }

    /**
     * Returns the description.
     * @return the description
     */
    public String getDescription()
    {
        return description;
    }

    /**
     * Sets the description.
     * @param description the description to set
     */
    public void setDescription(String description)
    {
        this.description = description;
    }

    /**
     * Returns the id.
     * @return the id
     */
    public Long getId()
    {
        return id;
    }

    /**
     * Sets the id.
     * @param id the id to set
     */
    public void setId(Long id)
    {
        this.id = id;
    }

    /**
     * Returns the referencedomain.
     * @return the referencedomain
     */
    public ReferenceDomain getReferencedomain()
    {
        return referencedomain;
    }

    /**
     * Sets the referencedomain.
     * @param referencedomain the referencedomain to set
     */
    public void setReferencedomain(ReferenceDomain referencedomain)
    {
        this.referencedomain = referencedomain;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public boolean equals(Object object)
    {
        if (!(object instanceof ReferenceCode))
        {
            return false;
        }
        ReferenceCode rhs = (ReferenceCode) object;
        return new EqualsBuilder()
            .append(this.code, rhs.code)
            .append(this.referencedomain, rhs.referencedomain)
            .isEquals();
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public int hashCode()
    {
        return new HashCodeBuilder(1560058887, -1822774051).append(this.code).append(this.referencedomain).toHashCode();
    }

    /**
     * {@inheritDoc}
     */
    public int compareTo(ReferenceCode o)
    {
        return new CompareToBuilder().append(this.description, o.description).append(this.code, o.code).toComparison();
    }

}
